<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
	<title>Bootstrap Flex</title>

	<!-- Bootstrap CSS -->
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/css/bootstrap.min.css" integrity="sha384-zCbKRCUGaJDkqS1kPbPd7TveP5iyJE0EjAuZQTgFLD2ylzuqKfdKlfG/eSrtxUkn" crossorigin="anonymous">
</head>
<body>
	<h1 class="text-center">Bootstrap Flex</h1>

	<!-- 
		Flexbox is used to manipulate and layout our elements. this can be done exclusively in CSS. However, using Bootstrap it is much easier and faster to implement flex, because all we have to do now is add the class d-flex to the "PARENT" of our flex items.
	
		Flex items, Flex Children, when adding d-flex to their parent, the items become inline and in a row. We can adjust their height and width not like your inline elements.

		Flex items: are in a row by default.

		Flex Directions:

		You can change the diretion of your flex items by adding flex-direction, however, by default, flex-row is the arrangement of our flex items.

		Flex Row Revense
			starts our items from the opposite side (right) and reverses the order of our flex items.

		flex-row starts from left to right. (default)
		flex-row-reverse starts from right to left.

		Flex Column 
			Flex column will arrange our items from top to bottom and by default the flex items will occupy the width of its parent

		Flex column Reverse
			It does the same as flex-column just that is starts from the bottom to the top.

	 -->
	 <h3 class="text-center">Flex Row</h3>
	<div class="bg-dark d-flex mb-5" style="height: 80vh"> <!-- display-flex -->
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>		
	</div>
	<div class="bg-dark d-flex mb-4">
		<span class="bg-primary p-2">Span Flex 1</span>
		<span class="bg-danger p-2">Span Flex 2</span>
		<span class="bg-success p-2">Span Flex 3</span>
	</div>

	<h3 class="text-center my-5">Flex row Reverse</h3>
	<div class="d-flex flex-row-reverse bg-dark mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>		
	</div>

	<h3 class="text-center my-5">Flex Column</h3>
	<div class="d-flex flex-column bg-dark mb-4 p-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>	
	</div>
	<div class="d-flex flex-column bg-dark mb-4 p-4" style="height: 80vh">
		<!-- even with <span> same results will hapen -->
		<span class="bg-primary p-2" style="height: 300px; width: 300px;">Span Flex 1</span>
		<span class="bg-danger p-2" style="height: 30%; width: 30%;">Span Flex 2</span>
		<span class="bg-success p-2" style="height: 30%; width: 30%;">Span Flex 3</span>
	</div>

	<h3 class="my-5 text-center">Flex Column Reverse</h3>
	<div class="bg-dark d-flex flex-column-reverse mb-4 p-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>	
	</div>

	<!-- Justify Content X--><!-- Justify Content -->
	<!-- Justify Content X--><!-- Justify Content -->
	<!-- Justify Content X--><!-- Justify Content -->
	<!-- Justify Content X--><!-- Justify Content -->
	<h2 class="text-center my-5">Justify Content</h2>
	<!-- justify content allows us to manipulate and change the alignment of our flex items along our main axis. The main axis for flex-row item is our x-axis. Justify-content allows us to horizontally align our FLEX-ROW items -->
	<h3 class="text-center my-5">Justify Content Start</h3>
	<!-- justify-content-start the default value of justify-content for flex items. It allows us to align our flex items to the start of their main axis. For flex-row it starts from the left, for flex-row-reverse it starts from the right -->
	<div class="bg-dark	d-flex flex-row justify-content-start mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>	
	</div>
	<div class="bg-dark	d-flex flex-row-reverse justify-content-start mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>	
	</div>

	<h3 class="text-center my-5">Justify Content End</h3>
	<!-- aligns our flex items where our main axis ends. For flex-row, the end from the right, for flex-row-reverse, the is from the right. -->
	<div class="bg-dark	d-flex flex-row justify-content-end mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>	
	</div>
	<div class="bg-dark	d-flex flex-row-reverse justify-content-end mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>	
	</div>

	<h3 class="text-center my-5">Justify Content Center</h3>
	<!-- aligns our flex items at the center of the main axis. The main axis for both flex-row and flex-row-reverse is the x-axis. Therefore, with justify-content  -->
	<div class="bg-dark	d-flex flex-row justify-content-center mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>	
	</div>
	<div class="bg-dark	d-flex flex-row-reverse justify-content-center mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>	
	</div>

	<h3 class="text-center my-5">Justify Content Between</h3>
	<!-- justify content between add/distributes remaining spaces in between our items with equal spaces -->
	<div class="bg-dark	d-flex flex-row justify-content-between mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>	
		<div class="bg-warning p-2">Flex Item 4</div>	
		<div class="bg-info p-2">Flex Item 5</div>	
	</div>
	<div class="bg-dark	d-flex flex-row-reverse justify-content-between mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>	
	</div>

	<h3 class="text-center my-5">Justify Content Around</h3>
	<!-- Aligns our items by distributing space around your items. Meaning it will automatically calculate the space remaining and add that space around your items. ONLY AT THE SIDES, wrt to x-axis -->
	<div class="bg-dark	d-flex flex-row justify-content-around mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>	
		<div class="bg-warning p-2">Flex Item 4</div>	
		<div class="bg-info p-2">Flex Item 5</div>	
	</div>
	<div class="bg-dark	d-flex flex-row-reverse justify-content-around mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>	
	</div>

	<!-- Align Items Y--><!-- Align Items --><!-- Align Items -->
	<!-- Align Items Y--><!-- Align Items --><!-- Align Items -->
	<!-- Align Items Y--><!-- Align Items --><!-- Align Items -->
	<!-- Align Items Y--><!-- Align Items --><!-- Align Items -->
	<h2 class="text-center">Align Items</h2>
	<!-- align items -  aligns your items vertically for flex-row and flex-row-reverse-->
	<h2 class="text-center">Align Items Start</h2>
	<!-- align-items-start - aligns items at the start of the y-axis or cross-axis for flex-row and flex-row-reverse

		For flex-row and flex-row-reverse, the y-axis is the cross axis and the x-axis is their main axis.

		For flex-column and flex-column-reverse, the y-axis is the main axis and x-axis is the cross-axis.

	For flex-row and flex-row-reverse, the start of their y-axis is at the top.
	 -->
	<div class="d-flex flex-row align-items-start bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="d-flex flex-row-reverse align-items-start bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Align Items End</h3>
	<div class="d-flex flex-row align-items-end bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="d-flex flex-row-reverse align-items-end bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Align Center</h3>
	<!-- align-items-center allws us to align our flex-row and flex-row-reverse items at center, vertically. -->
	<div class="d-flex flex-row align-items-center bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="d-flex flex-row-reverse align-items-center bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>

	<h2 class="text-center my-5">Aligning Items Horizontally and Vertically</h2>
	<div class="d-flex flex-row align-items-end justify-content-end bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="d-flex flex-row align-items-end justify-content-around bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<div class="d-flex flex-row align-items-center justify-content-end bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	
	<h3 class="text-center my-5">Mini Activity with Flex Row</h3>
	
	<div class="d-flex flex-row justify-content-center align-items-center bg-dark" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>
	<br>

	<div class="d-flex flex-row justify-content-between align-items-center bg-dark" style="height:50vh;">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
	</div>


	<h2 class="text-center my-5">Flex Column with Align Items ans Justify Content</h2>
	<!-- 

			For flex-row and flex-row-reverse, align-items aligns our flex-row and flex-row-reverse VERTICALLY, justify-content aligns our flex-row and flex-row-reverse horizontally.

			For flex-column and flex-column-reverse, align-items aligns our flex-column and flex-column-reverse horizontally.
	 -->
	 <h4 class="text-center">Flex Column and Align Items Center</h4>
	<div class="d-flex flex-column align-items-center bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
		<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
	</div>
	<h4 class="text-center">Flex Column and Justify Content Center</h4>
	<div class="d-flex flex-column justify-content-center bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
		<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
	</div>

	<!-- Mini-Activity -->

	<h3 class="text-center my-5">Mini-Activity with Flex Column</h3>
	<div class="d-flex flex-column align-items-center justify-content-end bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
		<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
	</div>
	<div class="d-flex flex-column justify-content-center align-items-end bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
		<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
	</div>


	<h3 class="text-center my-5">Flex Column</h3>
	<h4 class="text-center my-5">Justify Content Between</h4>
	<div class="d-flex flex-column justify-content-between  bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
		<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
	</div>
	<h4 class="text-center my-5">Justify Content Around</h4>
	<div class="d-flex flex-column justify-content-around bg-dark mb-4" style="height:50vh;">
		<div class="bg-primary p-2" style="width:20%;">Flex Item 1</div>
		<div class="bg-danger p-2" style="width:20%;">Flex Item 2</div>
		<div class="bg-success p-2" style="width:20%;">Flex Item 3</div>
	</div>

	<h3 class="text-center my-5">Flex Wrap</h3>
	<!-- FLEX WRAP will manage the items hence that all the items will be seen on the page. -->
	<div class="d-flex flex-row flex-wrap justify-content-around bg-dark mb-4">
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>
		<div class="bg-primary p-2">Flex Item 1</div>
		<div class="bg-danger p-2">Flex Item 2</div>
		<div class="bg-success p-2">Flex Item 3</div>

	</div>


	<!-- JS Dependencies -->
	<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.1/dist/js/bootstrap.bundle.min.js" integrity="sha384-fQybjgWLrvvRgtW6bFlB7jaZrFsaBXjsOMm/tB9LTS58ONXgqbR9W8oWht/amnpF" crossorigin="anonymous"></script>
</body>
</html>